//Software base para OPM001
//Controlador ESP32
//Mapeamento dos IOs e definição das Seriais
// Definição dos pinos do controlador

//Entradas digitais
#define pin_X1 26
#define pin_X2 25
#define pin_X3 33 
#define pin_X4 32

//Entradas analógicas
#define pin_AI1 35
#define pin_AI2 34
#define pin_AI3 39
#define pin_AI4 36

//Saídas digitais
#define pin_Y1 23

//Pinos auxiliares
#define ENTX_pin 18 //Pino de comunicação RS485

//Variaveis para controle das entradas e saidas digitais
bool Digital_Out[1];
bool Digital_In[4];
int Analog_In[4];

void setup() {
  //Inicializa comunicações
  Serial.begin(115200); // (USB)
  Serial1.begin(115200); // (TTL)
  Serial2.begin(115200); //(485)

  //Inicializa hardware
  pinMode(pin_X1, INPUT);
  pinMode(pin_X2, INPUT);
  pinMode(pin_X3, INPUT);
  pinMode(pin_X4, INPUT);

  pinMode(pin_Y1, OUTPUT);
  pinMode(ENTX_pin, OUTPUT);

  digitalWrite(pin_Y1, LOW);
}

void loop() {
  //************************************************************************************
  //Leitura das entradas digitais
  //Esse código deve rodar sempre para leitura das entradas digitais
  //Utilizar o Array Digital_In[0] a Digital_In[3] no software para controle
  //************************************************************************************
  Digital_In[0] = !digitalRead(pin_X1);
  Digital_In[1] = !digitalRead(pin_X2);
  Digital_In[2] = !digitalRead(pin_X3);
  Digital_In[3] = !digitalRead(pin_X4);

  //************************************************************************************
  //Acionamento relé
  //Esse código deve rodar sempre para acionar o relé
  //Utilizar o Array Digital_Out[0] no software para controle
  //************************************************************************************
  digitalWrite(pin_Y1, Digital_Out[0]); 

  //************************************************************************************
  //Leitura das entradas Analógicas
  //Esse código deve rodar sempre para leitura das entradas analógicas
  //Utilizar o Array Analog_In[0] a Array Analog_In[3] no software para controle
  //************************************************************************************
  Analog_In[0] = analogRead(pin_AI1);
  Analog_In[1] = analogRead(pin_AI2);
  Analog_In[2] = analogRead(pin_AI3);
  Analog_In[3] = analogRead(pin_AI4);
}
